"use strict";

require("core-js/modules/es.symbol");

require("core-js/modules/es.array.filter");

require("core-js/modules/es.array.for-each");

require("core-js/modules/es.date.to-string");

require("core-js/modules/es.object.define-properties");

require("core-js/modules/es.object.define-property");

require("core-js/modules/es.object.get-own-property-descriptor");

require("core-js/modules/es.object.get-own-property-descriptors");

require("core-js/modules/es.object.keys");

require("core-js/modules/es.object.to-string");

require("core-js/modules/es.regexp.to-string");

require("core-js/modules/web.dom-collections.for-each");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var getTimeSignature = function getTimeSignature(bars, barView) {
  var settings = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};

  if (!bars[0].timeSignature) {
    throw new TypeError("first bar has no time signature");
  }

  var DEFAULT_SIZE = 20;
  var DEFAULT_COLOR = "#000";
  var color = settings.color || DEFAULT_COLOR;
  var size = settings.size || DEFAULT_SIZE;
  var timeSig = bars[0].timeSignature;
  var attrTimeSig = {
    fill: color,
    fontSize: size,
    textAnchor: "start"
  };
  var timeSigX = bars[0].dimensions.x - 15;
  var baseY = bars[0].dimensions.y + barView.bar.height / 2 + 5;
  var distance = 10;
  return [_objectSpread({
    x: timeSigX,
    y: baseY - distance,
    text: timeSig[0].toString()
  }, attrTimeSig), _objectSpread({
    x: timeSigX,
    y: baseY + distance,
    text: timeSig[1].toString()
  }, attrTimeSig)];
};

var _default = getTimeSignature;
exports["default"] = _default;